#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#define DIMENSIONE 100
void main (int argc, char **argv) {

     int myrank, size, blocco, offset;
     MPI_Status status;
     int a[DIMENSIONE];
     int b[DIMENSIONE];
     int valore;
     int conta_risposte=0;
     int x;
          
     MPI_Init(&argc, &argv); /* Initialize MPI */
     MPI_Comm_rank(MPI_COMM_WORLD, &myrank); /* Get rank */
     MPI_Comm_size(MPI_COMM_WORLD, &size);
     
     blocco=DIMENSIONE/(size-1);
     
     if (myrank==0)
     {
        printf("P %d, inizio esecuzione con %d processi\n",myrank,size);
        
        int i;
        for(i=0;i<DIMENSIONE;i++)
           a[i]=i;
        
        
        //offset=DIMENSIONE%size;
        valore=60;
        
        for(i=1;i<size;i++)
        {
           printf("Trasmetto al processo %d\n",i);
           MPI_Send(a+((i-1)*blocco), blocco, MPI_INT, i, i, MPI_COMM_WORLD );
           MPI_Send(&valore,1,MPI_INT,i,i,MPI_COMM_WORLD);
        }
        
        while (conta_risposte<(size-1))
        {
           MPI_Recv(&x,1,MPI_INT,MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,&status);   
           printf("P %d, ho ricevuto un messaggio da %d, l'indice e' %d\n",myrank,status.MPI_SOURCE,x);
           conta_risposte++;
        }
        
     }
     
     else
     {
         int count=0;
         MPI_Recv(b,blocco,MPI_INT,0,myrank,MPI_COMM_WORLD,&status);
         MPI_Get_count(&status,MPI_INT,&count);
         MPI_Recv(&valore,1,MPI_INT,0,myrank,MPI_COMM_WORLD,&status);
         
         printf("P %d; blocco: %d; conteggio valori: %d\n",myrank,blocco,count);
         
         int index=0;
         int trovato=0;
         
         printf("P %d, valore da cercare %d, inizio la ricerca\n",myrank,valore);
         
         while ((!trovato) && (index<blocco))
         {
               if (b[index]==valore)
                  trovato=1;
               index++;
         }
         
         if (trovato)
         {
            int indice = (index-1);
            printf("P %d, ho trovato il valore alla posizione %d\n",myrank,index-1);
            MPI_Send(&indice,1,MPI_INT,0,100,MPI_COMM_WORLD);
         }
         else
         {
            int indice = -1;
            printf("P %d, non ho trovato il valore\n",myrank);
            MPI_Send(&indice,1,MPI_INT,0,100,MPI_COMM_WORLD);
         }
     }
     MPI_Finalize();
}
